clear all
close all

%problem definition
mu = 10e-3; %Viscosity
rho = 1000.0; %Density

nu = mu/rho;
Lx = 1.0; %Domain size
Ly = 1.0; %Domain size


%Computational variables
Npoints = 40;
dt = 1.0;
dx = Lx/(Npoints-2);
dy = Ly/(Npoints-2);
u = zeros(Npoints,Npoints);
un = zeros(Npoints,Npoints);

%Choose location and size of initial velocity pertubation
for i=15:25
    u(i,i) = 1.0;
    u(i,end-i) = 1.0;
end

%Iterate in time
for it =1:10000
    for i=2:Npoints-1
    for j=2:Npoints-1
        un(i,j) = u(i,j) ...
                 +dt*nu*((u(i+1,j)-2.0*u(i,j)+u(i-1,j))/dx^2 ...
                        +(u(i,j+1)-2.0*u(i,j)+u(i,j-1))/dy^2);
    end
    end
    u = un;
    it
    %Enforce Boundary Condition (after updating)
    u(:,1) = 0.0; %Bottom
    u(1,:) = 0.0; %Left
    u(end,:) = 0.0; %Right
    u(:,end) = 0.0; %Top
    imagesc(u')
    colormap(bone)
    colorbar
    pause(0.0001)
end
