clear all
close all

C = 0.25;
dx = 1.0;
dy = 1.0;
Npoints = 9;
eps = 1e-8;
f = zeros(Npoints, Npoints);
fprev = zeros(Npoints, Npoints);
for it=1:1000

  %Set Boundary Condition
  f(:,1) = 1.0; %Bottom
  f(1,:) = f(end-1,:); %Left
  f(end,:) = f(2,:); %Right
  f(:,end) = 0.0; %Top

  for i=2:(Npoints-1)
    for j=2:(Npoints-1)
      f(i,j)= C*((f(i+1,j)+f(i-1,j))/dx^2 ...
	           + (f(i,j+1)+f(i,j-1))/dy^2);
    end
  end
  
  error = sum(sum(abs(f-fprev)));
  disp(["Iteration =", it, " Error = ", error])
  if (error  < eps)
     break
  else
     fprev = f;
  end
  imagesc(f')
  colormap(bone)
  colorbar
  pause(0.001)
end
